locals {
  {{ variable_prefix }}__linux_flavor = "ubuntu20.04"
  {{ variable_prefix }}__ssh_username = "ubuntu"

  {{ variable_prefix }}__image_prefix_name = "${var.target}-${var.target_version}"
  {{ variable_prefix }}__image_suffix_name = "${var.timestamp}"
  {{ variable_prefix }}__ami_name          = "${local.{{ variable_prefix }}__image_prefix_name}-${local.{{ variable_prefix }}__linux_flavor}-${local.{{ variable_prefix }}__image_suffix_name}"
  {{ variable_prefix }}__ami_ssm_parameter = "/${var.target}/${var.target_version}/${local.{{ variable_prefix }}__linux_flavor}-${var.timestamp}"
}

source "amazon-ebs" "ubuntu2004" {
  ami_name      = local.{{ variable_prefix }}__ami_name
  instance_type = var.instance_type
  region        = var.region
  source_ami_filter {
    filters = {
      # AWS SSM PARAMETERS FOR UBUNTU
      # https://cloud-images.ubuntu.com/locator/ec2/
      # https://discourse.ubuntu.com/t/finding-ubuntu-images-with-the-aws-ssm-parameter-store/15507
      name                = "ubuntu/images/hvm-ssd/ubuntu-focal-20.04-amd64-server-*"
      root-device-type    = "ebs"
      virtualization-type = "hvm"
    }
    most_recent = true
    owners       = ["099720109477"]
  }
  ssh_username = local.{{ variable_prefix }}__ssh_username
}

build {
  sources = [
    "source.amazon-ebs.ubuntu2004"
  ]

  provisioner "ansible" { # tested versions: 8.2.0, 8.4.0
    extra_arguments = [
      "-v",
    ]
    user = local.{{ variable_prefix }}__ssh_username
    use_proxy = false # https://github.com/ansible/ansible/issues/57542
    ansible_env_vars = [
      "ANSIBLE_HOST_KEY_CHECKING=False"
    ]
    playbook_file = "./main.yml" # playbook generated from templates/main.yml.j2
  }

  # post-processor "shell-local" {
  #   environment_vars = [
  #     "PARAMETER_NAME=${local.ami_ssm_parameter}",
  #     "AMI_NAME=${local.ami_name}"
  #   ]
  #   script = "postprocessor/register_ami.sh"
  # }
}